#pragma once

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <GL/glut.h>
#include "v3.h"
#include "ppc.h"

class FrameBuffer : public Fl_Gl_Window {
public:
  unsigned int *pix;
  float *zb;
  int w, h;
  FrameBuffer(int u0, int v0, int _w, int _h);
  void Set(unsigned int color);
  void Set(int u, int v, unsigned int col);
  void Set(FrameBuffer *fb);
  unsigned int Get(int u, int v);
  unsigned int GetST(float s, float t);
  V3 Getv(int u, int v);
  void SetGuarded(int u, int v, unsigned int col);
  void draw();
  void DrawPoint(int u, int v, int psize, 
    unsigned int color);
  void DrawPoint3D(V3 P, int psize, 
    unsigned int color, PPC *ppc);
  void DrawCircle(float uf, float vf, 
    float r, unsigned int color);
  void DrawSegment(V3 p0, V3 p1, 
    unsigned int color);
  void DrawSegment(V3 p0, V3 p1, 
    V3 c0, V3 c1);
  void DrawSegment3D(V3 p0, V3 p1, 
    V3 c0, V3 c1, PPC *ppc);
  void DrawAABB3D(AABB &aabb, V3 col[2], PPC *ppc);
  FrameBuffer *FindEdges();
  bool ClipBB(AABB &bb);
  void FrameSetup(unsigned int color);
  void SetZB(float currz, int u, int v);
  bool IsCloser(float currz, int u, int v);
  bool IsVisible(float currz, int u, int v);
  void KeyboardHandle();
  int handle(int guievent);
  void SetChecker(unsigned int cols[2], int cw);
  bool isHW;
  int Load(char *tiffFileName);
  void Save(char *tiffFileName);
};
