#pragma once

#include "v3.h"
#include "m3x3.h"
class FrameBuffer;

class PPC {
public:
  V3 a, b, c, C;
  int w, h;
  PPC(int _w, int _h, float hfov);
  bool Project(V3 P, V3 &projP);
  V3 Unproject(int u, int v, float z);
  void Visualize(PPC *ppc, float d, FrameBuffer *fb);
  void Translate(V3 trans);
  void TranslateFW(float step);
  V3 GetVD();
  float GetF();
  void ChangeFocalLength(float scalef);
  void Pan(float thetad);
  void Tilt(float thetad);
  void Roll(float thetad);
  void SetViewGL();
  void Save(char *fname);
  void Load(char *fname);
  float ComputeError(V3 *pts, V3 *markers, int n);
};