#include "scene.h"
#include "triangle.h"
#include "tmesh.h"

Scene *scene;

#include <iostream>

using namespace std;


Scene::Scene() {

  tm1 = tm2 = 0;
  gui = new GUI();
  gui->show();

  int u0 = 20;
  int v0 = 50;
  int sci = 2;
  int w = sci*320;
  int h = sci*240;
  fb = new FrameBuffer(u0, v0, w, h);
  fb->label("SW framebuffer");
  fb->show();
  gui->uiw->position(fb->w+20+20, 50);
  Setup();
  Render();

}

void Scene::Render() {

  fb->FrameSetup(0xFF00AAFF);
  if (tm1)
//    tm1->RenderFilled(V3(1.0f, 0.0f, 0.0f), ppc, fb, 0, 0);
    tm1->RenderWireFrame(V3(1.0f, 0.0f, 0.0f), ppc, fb);
  fb->redraw();

}

void Scene::Setup() {

  float hfov = 45.0f;
  ppc = new PPC(fb->w, fb->h, hfov);
  tm1 = new TMesh();
  tm1->Load("geometry/teapot1k.bin");
  tm1->SetCenter(V3(0.0f, 0.0f, -100.0f));
  tm1->Scale(100.0f);

}

void Scene::DBG() {

  FrameBuffer *tmp = new FrameBuffer(0, 0, 10, 10);
  tmp->Load("mydbg/GrandCanyon2.tif");
  tmp->label("loaded image");


  tmp->DrawCircle(230.0f, 110.0f, 100.0f, 0xFF0000FF);

#if 0
  int u, v;
  for (v = 0; v < tmp->h/2; v++) {
    for (u = 0; u < tmp->w; u++) {
      unsigned int currColor = tmp->Get(u, v);
      unsigned int red = ((unsigned char*)&currColor)[0];
      red = 255-red;
      unsigned int green = ((unsigned char*)&currColor)[1];
      green = 255-green;
      unsigned int blue = ((unsigned char*)&currColor)[2];
      blue = 255-blue;
      currColor = 0xFF000000 + blue*256*256 + green*256 + red;
      tmp->Set(u, v, currColor);
    }
  }
#endif

  tmp->show();

  tmp->Save("mydbg/tmp.tif");


}


void Scene::Pan() {

  cerr << "INFO: pressed pan button " << endl;

}